Afhankelijk van wat er gebeurt op de hub of de aanvraag die u deed, zal de
client een bericht weergeven.

Alle berichten hebben het volgende formaat:
xxxxx] "yyyyyy"aaaaaaaaa|

met:
* xxxxx als 5 karakter lange code die het type bericht identificeert
  Laten we ket MTYPE noemen.
* yyyyyy wordt hoofdzakelijk in debug functies gebruikt. Meestal is yyyyyy 
  leeg, anders is het de functienaam.
* aaaa is een set van een of meerdere codes (gescheiden door | bij meer dan
  een code). De regel eindigd altijd met een |. Laten we het INS noemen.

Lijst van MTYPE:
* "ERR  ": het is een foutbericht.

* "DEBUG": het is een debugbericht. Tenzij u de debug modus aan heeft staan,
	   zult u nooit dit type bericht ontvangen. Ze zijn er alleen om
	   het debuggen te vergemakkelijken.

* "INFO ": het is een informatie. Het bericht bevat verschillende informatie.
           U kan berichten van dit type negeren. Ze zullen in de toekomst
	   verwijdert worden en vervangen worden door DEBUG.

* "USER ": U ontvangt dit bericht na het gebruik van /ULIST (om de hub's
           gebruikerslijst te ontvangen). INS bevat 1 gebruikersbijnaam.
	   Er is 1 bericht per gebruiker.

* "OP   ": hetzelfde als "USER", maar de bijnaam is een beheerderbijnaam.
           beheerders verschijnen ook in de USER lijst.

* "USER+": een gebruiker is de hub binnengekomen. INS bevat de bijnaam van de
	   gebruiker.

* "USER-": een gebruiker heeft de hub verlaten. INS bevat de bijnaam van de
	   gebruiker.

* "UINFO": na gebruik van /UINFO, ontvangt u de informatie over de aangevraagde
	   gebruiker. Het is niet noodzakelijk deze functie aan te roepen nadat
	   u een USER+ ontvangt, u zou het alleen maar hoeven te gebruiken na een
	   /ULIST. INS heeft de volgende inhoud: "aaa bbb ccc [(ddd)eee] 'ffff' gggg"
               met: aaa als de bijnaam van de gebruiker
                    bbb is de grootte van de gedeelde gegevens (in bytes) van de gebruiker
                    ccc is het type verbinding (zie /CNX voor verbindingstypes)
                    ddd is een optie met de volgende betekenis:
                               bit 0: altijd aan
                               bit 1: de gebruiker is hier(aan), anders is hij weg(uit).
                    eee negeer dit veld, het is de mens-leesbare vorm van ddd.
                    fff is het emailadres van de gebruiker (kan leeg zijn).
                    ggg is de beschrijving van de gebruiker (kan leeg zijn).

* "CHAT ": het is een binnenkomend bericht van de publieke chat. INS is het bericht.
	   Om problemen te voorkomen, wordt de \n in een bericht vervangen
	   door \r.

* "HUBNM": het is de hubnaam. INS is de naam van de hub.

* "SREST": na een /SRCH, moet u berichten van dit type ontvangen. Dit zijn de
	   resultaten van uw zoekopdracht. 1 resultaat per bericht. INS heeft
	   het volgende formaat: aaa|bbb|ccc|ddd|eee|fff
           met: aaa als de bijnaam van de gebruiker.
	        bbb als de bestandsnaam (inclusief zijn pad. \ is het
		    scheidingsteken)
		ccc als de bestandsgrootte
		ddd als de vrije slot ratio ("f/t": f=vrij slot, t=totaal slot) 
		eee als de hubnaam
		fff als de hubip
	   na fff, kan er een optioneel veld zijn (genaamd ggg). ggg bestaat alleen
	   als deze zoekopdracht een inhoud-zoekresultaat is (/CSRCH). In dat geval
	   is ggg de naam van het gezochte lokale bestand (degene die aan
	   het /CSRCH commando opgegeven is).

* "$USER": ongebruikt

* "$UL+ ": een upload start (=iemand download van uw computer).
	   INS is "aaa|bbb" met aaa als de bijnaam van de downloader en bbb als
	   de lokale bestandsnaam.

* "$UL= ": een upload loopt nu. INS is hetzelfde als "XFERR".

* "$UL- ": een upload is succesvol afgerond. INS is hetzelfde als "$UL+ ".

* "$UL# ": een upload is afgebroken. INS is hetzelfde als "$UL+ ".

* "$DL+ ": u start een download. INS is hetzelfde als "$UL+ ".

* "$DL= ": een download is nu bezig. INS is hetzelfde als in "XFERR".

* "$DL- ": een download is succesvol geeindigd. INS is hetzelfde als "$UL+ ".

* "$DL# ": een download is afgebroken. INS is hetzelfde als "$UL+ ".
           INS kan ook aaa|bbb|ccc zijn met ccc als de reden van de fout.
           Als de fout herstelbaar is (een netwerkfout wel, een schijf vol niet),
	   wordt de downloadtaak automatisch opnieuw in de wachtrij CMDKB gezet
	   om herstart te worden. 

* "$LS+ ": een gebruikerbestandslijst download start. INS is de externe bijnaam.

* "$LS- ": een gebruikerbestandslijst download eindigde succesvol. INS is de
	   externe bijnaam.

* "$LS# ": een gebruikerbestandslijst download faalde. INS is de externe bijnaam.

* "HUB+ ": de hub is bereikt.

* "HUB- ": verbinding met de hub verbroken. INS is een tekst regel.
	   Totdat alle lopende overdrachten eindigen, zal de client niet
	   afsluiten. (ziek /KILL)

           Pas op: u kan meer HUB- berichten dan HUB+ berichten ontvangen.
	   Na het verbreken van de verbinding kan u een HUB- voor elke
	   herverbindingspoging ontvangen.

* "PRIV ": U ontvangt een prive bericht van een andere gebruiker. INS inhoud is
           "aaa|bbb" met aaa als een bijnaam een bbb de inhoud van het bericht.
	   bbb heeft altijd het formaat "<xxx> spraak" met xxx de bijnaam van
	   de gebruiker die "spraak" zegt.

           Voorbeeld. U bent AAA, Andere gebruiker is CCC en beide zeggen BBB.
	   U doet: /PRIV CCC BBB
		   u ontvangt "CCC|<AAA> BBB" (dit is de lokale echo).
	   Als u "CCC|<CCC> BBB" ontvangt, betekend dit dat de andere gebruiker
	   u BBB zendt.
           Dus kunt u altijd CCC gebruiken om een prive gesprek met een
	   gebruiker te associeren.

* "XFERR": Dit is geen overdrachtsfout. Het is een ingang in de lopende
	   overdrachten lijst. INS is "aaa|bbb|ccc" met aaa als een ID die
	   de overdracht identificeert (zie /KILL). bbb is de bijnaam van de
	   externe gebruiker (degene die download of waarvan u download). ccc
	   is:
                Idle       : het is een nog niet gestarte overdracht.
                LS/        : het is een download. U haalt de gebruikerbestands-
			     lijst op.
                UL/ficnaam : het is een upload, ficnaam is de lokale
			     bestandsnaam.
                DL/xxxxxxx : het is een download, met xxxxxxx is:
                   ddd|eee|fff|ggg|hhh|iii:jjj
               - ddd is de externe bestandsnaam (gevolgd door een $ en een
	         digit).
               - eee is de lokale bestandsnaam.
               - fff is de download startpositie in bytes.
               - ggg is de grootte van het complete bestand.
               - hhh is de download starttijd (verkregen van time()).
               - iii is de externe hostnaam (het IP-adres of de FQDN)
               - jjj is de externe hostpoort
        
                
* "XFERQ": Het is een ingang in de lijst van wachtende (nog niet gestartte)
	   overdrachten. INS is "eee|aaa*bbb*ccc*ddd". * is de scheider. Het
	   kan elke karakter zijn behalve die gebruikt zijn in aaa,bbb,ccc of
	   ddd, \0 en \n.
           eee is de bijnaam van de externe gebruiker
           aaa is "DL/" (het is ee download)
           bbb is de naam van het lokale bestand (met pad)
           ccc is de naam van het externe bestand (met pad)
           ddd is de download startpositie.

           INS kan ook "eee|aaa" zijn. eee is altijd de bijnaam en aaa is "LS/"

* "CMDKB": het is een toetsenbord commando dat intern verzonden is. INS is 
	   "nnn|aaa|bbb". nnn is het identificatienummer van deze ingang. aaa is
	   een startdatum (in time() formaat). bbb is het commando om uit te
	   voeren. Als de geven datum bereikt word, wordt het commando bbb naar
	   de toetsenbord interpreter gezonden, alsof u het commando handmatig
	   ingevoerd zou hebben.

* "$DL~ ": een wachtende download is verwijderd omdat het te oud was (externe
	   gebruiker antwoord niet of is achter een firewall). Downloadtaken
	   worden automatisch opnieuw in de wachtrij CMDKB gezet om opnieuw
	   gestart te worden.

* "HUBGO": soms kan de hub u doorsturen naar een andere hub. INS is het adres
	   van de andere hub waar u heen zou moeten gaan.

           NB: als u deze hub herverwijzing ontvangt, doet de client niets.
	   U moet handmatig met de nieuwe hub herverbinden.

* "FLSTB": de code geeft het begin van een gebruikerbestandenlijst aan.
	   aaa is de bijnaam van de externe gebruiker.

* "FLST ": een regel die start met deze code wordt gegenereerd nadat u het
	   /LS commando gebruikt heeft. Elke FLST bevat de naam van een
	   bestand dat door een gebruiker gedeeld wordt. INS is "aaa|bbb|ccc"
	   met aaa als de externe gebruikers bijnaam, bbb is de bestandsnaam
	   (met zijn pad) en ccc is de bestandsgrootte. Alleen bestanden staan
	   in deze code, geen directories.

* "FLSTE": de code geeft aan dat het einde van een gebruikerbestandslijst
	   bereikt is. INS is "aaa|bbb|ccc" met aaa als de bijnaam van de
	   externe gebruiker, bbb is het aantal gedeelde bestanden in de lijst
	   en ccc is de grootte in bytes van alle gedeelde bestanden.

* "ASTRT": de code geeft aan dat een commando van de CMDKB lijst start. INS
	   is de commando die start.

* "ASTOP": de code geeft aan dat er een commando aan de CMDKB lijst is
	   toegevoegd. INS is het toegevoegde commando.

* "RFRSH": een overdrachtverbinding is geeindigd.

* "BXFER": begin van de xfer lijst. Na dit zal u XFERR, XFERQ en CMDKB
	   ontvangen. INS is leeg.

* "EXFER": einde van xfer lijst. INS is leeg.

* "VAR  ": geeft een interne var aan. INS is aaa|bbb met aaa als de var naam
	   en bbb als zijn waarde. Zie het Documentation/VAR.nl bestand voor
	   de lijst met var namen.

* "PASWD": de hub wilt dat de client een paswoord opgeeft voor deze bijnaam.
	   gebruik /PASSWD om er een op te geven.

* "ADMIN": de gebruiker is op de hub aangemeld als een beheerder.

* "$ULST": dit bericht bevat de statistieken van een upload. INS is
           "aaa:bbb/ccc/ddd/eee" met a als een ID die de overdracht 
	   identificeert (net zoals in /XFERR), bbb is de upload startpositie,
	   ccc is de totale bestandslengte (niet alleen het verzonden gedeelte),
	   ddd is de hoeveelheid gegevens die al verzonden zijn (niet inclusief
	   bbb) en eee is het aantal bytes te verzenden. Momenteel hebben we de
	   volgende relaties:
              bbb+eee=ccc  en  0<ddd<eee.

* "PRGBR": dit bericht wordt gebruikt om een taak, die een voortgangsbalk nodig
           heeft, te rapporteren. INS is als volgt "aaa|bbb|ccc[|ddd....]" met:
	      aaa is de naam van deze voortgangsbalk (u kan er meerdere
	          tegelijk hebben).
              bbb is het % vordering (gebruik 0 om een nieuwe balk te beginnen
	          en 100 om de balk te eindigen).
	      ccc, ddd, ... zijn teksten om in de balk weer te geven. U moet
	          ten minste 1 tekst hebben om weer te geven. (Als de tekst
                  een \n mocht bevatten, worden ze vervangen door \r).

* "GQLSB": begin van een GDL snellijst.

* "GQLSC": inhoud van een ingang in de GDL snellijst. INS is
           "aaa|bbb|ccc".
           met: aaa is de GDL ID.
                bbb is de lokale bestandsnaam
                ccc is de grootte van het bestand

* "GQLSE": begin van de GDL snellijst

* "GLSTB": begin van de GDL vollijst

* "GLSTC": inhoud van een ingang in de GDL vollijst. INS is
           "aaa|bbb|ccc|xxx|yyy|zzz|uuu|ddd|eee|fff" met:
                  aaa is de GDL ID.
                  bbb is de lokale bestandsnaam
                  ccc is de gootte van het bestand
                  xxx is het byte startpunt (=aantal bytes nog steeds hier
		      wanneer de GDL ingang aan een client gekoppelt wordt.
                  yyy is het aantal bytes ontvangen (inclusief xxx).
                  zzz is de starttijd (maaktijd voor nieuwe GDL, aankoppeltijd
		      voor aangekoppelde GDL
                  uuu is het aantal bytes ontvangen tijdens de laatste 10 
		      seconden. (waarschuwing, dit veld bestaat alleen sinds
		      DCTC v0.79.0)
                  ddd bevat 0 of meer ingangen van het volgende formaat en
		      gescheiden door |. ddd eindigd met een lege string.
                      Dit is de lijst met bronbestanden van de GDL.
                      xx$yy$zz$tt
                      met xx is een bijnaam
                          yy is een externe bestandsnaam
                          zz is de grootte van de externe bestandsnaam
                          tt is de status: 'W' voor wachten, 'T' voor
                               proberen en 'Rhhh[iii;jjj]' voor lopen (hhh is
                               het aantal bytes gedownload in het bereik, iii
                               is de download startpositie en jjj is de
                               download eindpositie (exclusief).
                  eee bevat 0 of meer ingangen van het volgende formaat en
		      gescheiden door |. eee eindigd met een lege string
                      Dit is de lijst met gedownloade segmenten van de GDL
                      xx$[iii;jjj]
                      met xx als de naam van de bestandsnaam die het segment
		             bevat.
			  iii is de startpositie van het segment en jjj is de
			      eindpositie van het segment (exclusief).
                  fff bevat 0 of meer ingangen van het volgende formaat en
		      gescheiden door |. fff eindigd met een lege string.
                      Dit is de lijst met autozoek patronen van de GDL
                      xx$yy?zz
                      met xx als de id van de autozoek ingang
                          yy als het autozoek bestandstype
                          zz als het autozoek zoekpatroon

* "GLSTE": einde van de GDL vollijst

* "UALSB": begin van de UADDR vollijst

* "UALSC": inhoud van een ingang in de UADDR vollijst. INS is
           "aaa|bbb" met:
                  aaa is de bijnaam (kan leeg zijn).
                  bbb is het host adres (hostip:hostpoort formaat)

* "UALSE": einde van het UADDR vollijst

* "UALS+": nieuw toegevoegde UADDR ingang. INS is zoals in UALSC.

* "UALS-": net verwijderde UADDR ingang. INS is zoals in UALSC.

* "LUSER": resultaat van een /LOCATEUSER commando. INS is aaa|bbb|ccc|ddd met:
              aaa is de bijnaam
	      bbb is de naam van de hub waar de gebruiker is
              ccc is de totale grootte van gedeelde bestanden van deze gebruiker
	          (kan een lege string zijn)
	      ddd is de IP:poort van deze gebruiker
	          (kan een lege string zijn)
		  
* "LSCCH": gebruikersbestandlijst opgehaald. INS is aaa met:
              aaa als de bijnaam. De bestandslijst wordt opgeslagen
	      in $(HOME)/.dctc/ls_cache/aaa in LS_cache formaat.